## nodejs 0.6.19~dfsg1

=== Makefile ===
PYTHON ?= python
WAF    = $(PYTHON) tools/waf-light

web_root = node@nodejs.org:~/web/nodejs.org/

#
# Because we recursively call make from waf we need to make sure that we are
# using the correct make. Not all makes are GNU Make, but this likely only
# works with gnu make. To deal with this we remember how the user invoked us
# via a make builtin variable and use that in all subsequent operations
#
export NODE_MAKE := $(MAKE)

all: program
	@-[ -f out/Release/node ] && ls -lh out/Release/node

all-progress:
	@$(WAF) -p build

program:
	@$(WAF) --product-type=program build

staticlib:
	@$(WAF) --product-type=cstaticlib build

dynamiclib:
	@$(WAF) --product-type=cshlib build

install:
	@$(WAF) install

uninstall:
	@$(WAF) uninstall

test: all
	$(PYTHON) tools/test.py --mode=release simple message

test-http1: all
	$(PYTHON) tools/test.py --mode=release --use-http1 simple message

test-valgrind: all
	$(PYTHON) tools/test.py --mode=release --valgrind simple message

node_modules/weak:
	@if [ ! -f node ]; then make all; fi
	@if [ ! -d node_modules ]; then mkdir -p node_modules; fi
	./node deps/npm/bin/npm-cli.js install weak \
		--prefix="$(shell pwd)" --unsafe-perm # go ahead and run as root.

test-gc: all node_modules/weak
	$(PYTHON) tools/test.py --mode=release gc

test-all: all node_modules/weak
	$(PYTHON) tools/test.py --mode=debug,release
	make test-npm

test-all-http1: all
	$(PYTHON) tools/test.py --mode=debug,release --use-http1

test-all-valgrind: all
	$(PYTHON) tools/test.py --mode=debug,release --valgrind

test-release: all
	$(PYTHON) tools/test.py --mode=release

test-debug: all
	$(PYTHON) tools/test.py --mode=debug

test-message: all
	$(PYTHON) tools/test.py message

test-simple: all
	$(PYTHON) tools/test.py simple

test-pummel: all
	$(PYTHON) tools/test.py pummel

test-internet: all
	$(PYTHON) tools/test.py internet

test-npm: all
	./node deps/npm/test/run.js

test-npm-publish: all
	npm_package_config_publishtest=true ./node deps/npm/test/run.js

out/Release/node: all

apidoc_sources = $(wildcard doc/api/*.markdown)
apidocs = $(addprefix out/,$(apidoc_sources:.markdown=.html)) \
          $(addprefix out/,$(apidoc_sources:.markdown=.json))

apidoc_dirs = out/doc out/doc/api/ out/doc/api/assets out/doc/about out/doc/community out/doc/logos out/doc/images

apiassets = $(subst api_assets,api/assets,$(addprefix out/,$(wildcard doc/api_assets/*)))

doc_images = $(addprefix out/,$(wildcard doc/images/* doc/*.jpg doc/*.png))

website_files = \
	out/doc/index.html    \
	out/doc/v0.4_announcement.html   \
	out/doc/cla.html      \
	out/doc/sh_main.js    \
	out/doc/sh_javascript.min.js \
	out/doc/sh_vim-dark.css \
	out/doc/sh.css \
	out/doc/favicon.ico   \
	out/doc/pipe.css \
	out/doc/about/index.html \
	out/doc/community/index.html \
	out/doc/logos/index.html \
	out/doc/changelog.html \
	$(doc_images)

doc: program $(apidoc_dirs) $(website_files) $(apiassets) $(apidocs) tools/doc/

$(apidoc_dirs):
	mkdir -p $@

out/doc/api/assets/%: doc/api_assets/% out/doc/api/assets/
	cp $< $@

out/doc/changelog.html: ChangeLog doc/changelog-head.html doc/changelog-foot.html tools/build-changelog.sh
	bash tools/build-changelog.sh

out/doc/%.html: doc/%.html
	cat $< | sed -e 's|__VERSION__|'$(VERSION)'|g' > $@

out/doc/%: doc/%
	cp -r $< $@

out/doc/api/%.json: doc/api/%.markdown
	out/Release/node tools/doc/generate.js --format=json $< > $@

out/doc/api/%.html: doc/api/%.markdown
	out/Release/node tools/doc/generate.js --format=html --template=doc/template.html $< > $@

email.md: ChangeLog tools/email-footer.md
	bash tools/changelog-head.sh | sed 's|^\* #|* \\#|g' > $@
	cat tools/email-footer.md | sed -e 's|__VERSION__|'$(VERSION)'|g' >> $@

blog.html: email.md
	cat $< | ./node tools/doc/node_modules/.bin/marked > $@

website-upload: doc
	rsync -r out/doc/ node@nodejs.org:~/web/nodejs.org/
	ssh node@nodejs.org '\
    rm -f ~/web/nodejs.org/dist/latest &&\
    ln -s $(VERSION) ~/web/nodejs.org/dist/latest &&\
    rm -f ~/web/nodejs.org/docs/latest &&\
    ln -s $(VERSION) ~/web/nodejs.org/docs/latest &&\
    rm -f ~/web/nodejs.org/dist/node-latest.tar.gz &&\
    ln -s $(VERSION)/node-$(VERSION).tar.gz ~/web/nodejs.org/dist/node-latest.tar.gz'

docopen: out/doc/api/all.html
	-google-chrome out/doc/api/all.html

docclean:
	-rm -rf out/doc

clean:
	$(WAF) clean
	-find tools -name "*.pyc" | xargs rm -f
	-rm -rf blog.html email.md
	-rm -rf node_modules

distclean: docclean
	-find tools -name "*.pyc" | xargs rm -f
	-rm -rf dist-osx
	-rm -rf out/ node node_g
	-rm -rf blog.html email.md

check:
	@tools/waf-light check

VERSION=v$(shell $(PYTHON) tools/getnodeversion.py)
TARNAME=node-$(VERSION)
TARBALL=$(TARNAME).tar.gz
PKG=out/$(TARNAME).pkg

packagemaker=/Developer/Applications/Utilities/PackageMaker.app/Contents/MacOS/PackageMaker

#dist: doc/node.1 doc/api
dist: $(TARBALL) $(PKG)

PKGDIR=out/dist-osx

pkg: $(PKG)

$(PKG):
	-rm -rf $(PKGDIR)
	# Need to remove deps between architecture changes.
	rm -rf out/*/deps
	$(WAF) configure --prefix=/usr/local --without-snapshot --dest-cpu=ia32
	CFLAGS=-m32 DESTDIR=$(PKGDIR)/32 $(WAF) install
	rm -rf out/*/deps
	$(WAF) configure --prefix=/usr/local --without-snapshot --dest-cpu=x64
	CFLAGS=-m64 DESTDIR=$(PKGDIR) $(WAF) install
	lipo $(PKGDIR)/32/usr/local/bin/node \
		$(PKGDIR)/usr/local/bin/node \
		-output $(PKGDIR)/usr/local/bin/node-universal \
		-create
	mv $(PKGDIR)/usr/local/bin/node-universal $(PKGDIR)/usr/local/bin/node
	rm -rf $(PKGDIR)/32
	$(packagemaker) \
		--id "org.nodejs.NodeJS-$(VERSION)" \
		--doc tools/osx-pkg.pmdoc \
		--out $(PKG)

$(TARBALL): out/doc
	git archive --format=tar --prefix=$(TARNAME)/ HEAD | tar xf -
	mkdir -p $(TARNAME)/doc
	cp doc/node.1 $(TARNAME)/doc/node.1
	cp -r out/doc/api $(TARNAME)/doc/api
	rm -rf $(TARNAME)/deps/v8/test # too big
	rm -rf $(TARNAME)/doc/images # too big
	tar -cf $(TARNAME).tar $(TARNAME)
	rm -rf $(TARNAME)
	gzip -f -9 $(TARNAME).tar

dist-upload: $(TARBALL) $(PKG)
	ssh node@nodejs.org mkdir -p web/nodejs.org/dist/$(VERSION)
	scp $(TARBALL) node@nodejs.org:~/web/nodejs.org/dist/$(VERSION)/$(TARBALL)
	scp $(PKG) node@nodejs.org:~/web/nodejs.org/dist/$(VERSION)/$(TARNAME).pkg

bench:
	 benchmark/http_simple_bench.sh

bench-idle:
	./node benchmark/idle_server.js &
	sleep 1
	./node benchmark/idle_clients.js &

jslint:
	PYTHONPATH=tools/closure_linter/ $(PYTHON) tools/closure_linter/closure_linter/gjslint.py --unix_mode --strict --nojsdoc -r lib/ -r src/ -r test/ --exclude_files lib/punycode.js

cpplint:
	@$(PYTHON) tools/cpplint.py $(wildcard src/*.cc src/*.h src/*.c)

lint: jslint cpplint

.PHONY: lint cpplint jslint bench clean docopen docclean doc dist distclean dist-upload check uninstall install all program staticlib dynamiclib test test-all website-upload

=== wscript ===
#!/usr/bin/env python

# Copyright Joyent, Inc. and other Node contributors.
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to permit
# persons to whom the Software is furnished to do so, subject to the
# following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
# NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
# USE OR OTHER DEALINGS IN THE SOFTWARE.

import re
import Options
import sys, os, shutil, glob
import Utils
from Utils import cmd_output
from os.path import join, dirname, abspath, normpath
from logging import fatal

cwd = os.getcwd()
APPNAME="node.js"

# Use the directory that this file is found in to find the tools
# directory where the js2c.py file can be found.
sys.path.append(sys.argv[0] + '/tools');
import js2c

if sys.platform.startswith("cygwin"):
  print "cygwin not supported"
  sys.exit(1)

srcdir = '.'
blddir = 'out'
supported_archs = ('arm', 'ia32', 'x64') # 'mips' supported by v8, but not node

jobs=1
if os.environ.has_key('JOBS'):
  jobs = int(os.environ['JOBS'])

def safe_path(path):
  return path.replace("\\", "/")

def canonical_cpu_type(arch):
  m = {'x86': 'ia32', 'i386':'ia32', 'x86_64':'x64', 'amd64':'x64'}
  if arch in m: arch = m[arch]
  if not arch in supported_archs:
    raise Exception("supported architectures are "+', '.join(supported_archs)+\
                    " but NOT '" + arch + "'.")
  return arch

def set_options(opt):
  # the gcc module provides a --debug-level option
  opt.tool_options('compiler_cxx')
  opt.tool_options('compiler_cc')
  opt.tool_options('misc')
  opt.add_option( '--libdir'
                , action='store'
                , type='string'
                , default=False
                , help='Install into this libdir [Release: ${PREFIX}/lib]'
                )
  opt.add_option( '--debug'
                , action='store_true'
                , default=False
                , help='Build debug variant [Release: False]'
                , dest='debug'
                )
  opt.add_option( '--profile'
                , action='store_true'
                , default=False
                , help='Enable profiling [Release: False]'
                , dest='profile'
                )
  opt.add_option( '--efence'
                , action='store_true'
                , default=False
                , help='Build with -lefence for debugging [Release: False]'
                , dest='efence'
                )

  opt.add_option( '--without-npm'
                , action='store_true'
                , default=False
                , help='Don\'t install the bundled npm package manager [Release: False]'
                , dest='without_npm'
                )

  opt.add_option( '--without-snapshot'
                , action='store_true'
                , default=False
                , help='Build without snapshotting V8 libraries. You might want to set this for cross-compiling. [Release: False]'
                , dest='without_snapshot'
                )

  opt.add_option( '--without-ssl'
                , action='store_true'
                , default=False
                , help='Build without SSL'
                , dest='without_ssl'
                )


  opt.add_option('--shared-v8'
                , action='store_true'
                , default=False
                , help='Link to a shared V8 DLL instead of static linking'
                , dest='shared_v8'
                )

  opt.add_option( '--shared-v8-includes'
                , action='store'
                , default=False
                , help='Directory containing V8 header files'
                , dest='shared_v8_includes'
                )

  opt.add_option( '--shared-v8-libpath'
                , action='store'
                , default=False
                , help='A directory to search for the shared V8 DLL'
                , dest='shared_v8_libpath'
                )

  opt.add_option( '--shared-v8-libname'
                , action='store'
                , default=False
                , help="Alternative lib name to link to (default: 'v8')"
                , dest='shared_v8_libname'
                )

  opt.add_option( '--openssl-includes'
                , action='store'
                , default=False
                , help='A directory to search for the OpenSSL includes'
                , dest='openssl_includes'
                )

  opt.add_option( '--openssl-libpath'
                , action='store'
                , default=False
                , help="A directory to search for the OpenSSL libraries"
                , dest='openssl_libpath'
                )

  opt.add_option( '--no-ssl2'
                , action='store_true'
                , default=False
                , help="Disable OpenSSL v2"
                , dest='openssl_nov2'
                )

  opt.add_option( '--gdb'
                , action='store_true'
                , default=False
                , help="add gdb support"
                , dest='use_gdbjit'
                )


  opt.add_option( '--shared-zlib'
                , action='store_true'
                , default=False
                , help='Link to a shared zlib DLL instead of static linking'
                , dest='shared_zlib'
                )

  opt.add_option( '--shared-zlib-includes'
                , action='store'
                , default=False
                , help='Directory containing zlib header files'
                , dest='shared_zlib_includes'
                )

  opt.add_option( '--shared-zlib-libpath'
                , action='store'
                , default=False
                , help='A directory to search for the shared zlib DLL'
                , dest='shared_zlib_libpath'
                )


  opt.add_option( '--shared-cares'
                , action='store_true'
                , default=False
                , help='Link to a shared C-Ares DLL instead of static linking'
                , dest='shared_cares'
                )

  opt.add_option( '--shared-cares-includes'
                , action='store'
                , default=False
                , help='Directory containing C-Ares header files'
                , dest='shared_cares_includes'
                )

  opt.add_option( '--shared-cares-libpath'
                , action='store'
                , default=False
                , help='A directory to search for the shared C-Ares DLL'
                , dest='shared_cares_libpath'
                )


  opt.add_option( '--with-dtrace'
                , action='store_true'
                , default=False
                , help='Build with DTrace (experimental)'
                , dest='dtrace'
                )
 

  opt.add_option( '--product-type'
                , action='store'
                , default='program'
                , help='What kind of product to produce (program, cstaticlib '\
                       'or cshlib) [default: %default]'
                , dest='product_type'
                )

  opt.add_option( '--dest-cpu'
                , action='store'
                , default=None
                , help='CPU architecture to build for. Valid values are: '+\
                       ', '.join(supported_archs)
                , dest='dest_cpu'
                )

def get_node_version():
  def get_define_value(lines, define):
    for line in lines:
      if define in line:
        return line.split()[-1] #define <NAME> <VALUE>

  lines = open("src/node_version.h").readlines()
  node_major_version = get_define_value(lines, 'NODE_MAJOR_VERSION')
  node_minor_version = get_define_value(lines, 'NODE_MINOR_VERSION')
  node_patch_version = get_define_value(lines, 'NODE_PATCH_VERSION')
  node_is_release    = get_define_value(lines, 'NODE_VERSION_IS_RELEASE')

  return "%s.%s.%s%s" % ( node_major_version,
                           node_minor_version,
                           node_patch_version,
                           node_is_release == "0" and "-pre" or ""
                         )

def arch_cflags(conf):
  flags = []

  if 'DEST_CPU' in conf.env:
    arch = conf.env['DEST_CPU']
    if arch == 'ia32':
      flags += ['-m32']
    elif arch == 'x64':
      flags += ['-m64']
    if sys.platform.startswith('darwin'):
      flags += ['-arch', {'ia32':'i386', 'x64':'x86_64'}.get(arch, arch)]

  return flags

def configure(conf):
  conf.check_tool('compiler_cxx')
  if not conf.env.CXX: conf.fatal('c++ compiler not found')
  conf.check_tool('compiler_cc')
  if not conf.env.CC: conf.fatal('c compiler not found')

  o = Options.options

  if o.libdir:
    conf.env['LIBDIR'] = o.libdir
  else:
    conf.env['LIBDIR'] = conf.env['PREFIX'] + '/lib'

  conf.env["USE_DEBUG"] = o.debug
  # Snapshot building does noet seem to work on mingw32
  conf.env["SNAPSHOT_V8"] = not o.without_snapshot and not sys.platform.startswith("win32")
  if sys.platform.startswith("sunos"):
    conf.env["SNAPSHOT_V8"] = False
  conf.env["USE_PROFILING"] = o.profile

  conf.env["USE_SHARED_V8"] = o.shared_v8 or o.shared_v8_includes or o.shared_v8_libpath or o.shared_v8_libname
  conf.env["USE_SHARED_CARES"] = o.shared_cares or o.shared_cares_includes or o.shared_cares_libpath
  conf.env["USE_SHARED_ZLIB"] = o.shared_zlib or o.shared_zlib_includes or o.shared_zlib_libpath

  conf.env["USE_GDBJIT"] = o.use_gdbjit
  conf.env['USE_NPM'] = not o.without_npm

  if not conf.env["USE_SHARED_ZLIB"] and not sys.platform.startswith("win32"):
    conf.env.append_value("LINKFLAGS", "-lz")

  conf.check(lib='dl', uselib_store='DL')
  if not sys.platform.startswith("sunos") and not sys.platform.startswith("win32"):
    conf.env.append_value("CCFLAGS", "-rdynamic")
    conf.env.append_value("LINKFLAGS_DL", "-rdynamic")

  if 'bsd' in sys.platform:
    conf.check(lib='kvm', uselib_store='KVM')

  #if Options.options.debug:
  #  conf.check(lib='profiler', uselib_store='PROFILER')

  if Options.options.dtrace:
    if not sys.platform.startswith("sunos"):
      conf.fatal('DTrace support only currently available on Solaris')

    conf.find_program('dtrace', var='DTRACE', mandatory=True)
    conf.env["USE_DTRACE"] = True
    conf.env.append_value("CXXFLAGS", "-DHAVE_DTRACE=1")

  if Options.options.efence:
    conf.check(lib='efence', libpath=['/usr/lib', '/usr/local/lib'], uselib_store='EFENCE')

  if 'bsd' in sys.platform:
     if not conf.check(lib="execinfo",
                       includes=['/usr/include', '/usr/local/include'],
                       libpath=['/usr/lib', '/usr/local/lib'],
                       uselib_store="EXECINFO"):
       conf.fatal("Install the libexecinfo port from /usr/ports/devel/libexecinfo.")

  if not Options.options.without_ssl:
    # Don't override explicitly supplied openssl paths with pkg-config results.
    explicit_openssl = o.openssl_includes or o.openssl_libpath

    # Disable ssl v2 methods
    if o.openssl_nov2:
      conf.env.append_value("CPPFLAGS", "-DOPENSSL_NO_SSL2=1")

    if not explicit_openssl and conf.check_cfg(package='openssl',
                                               args='--cflags --libs',
                                               uselib_store='OPENSSL'):
      Options.options.use_openssl = conf.env["USE_OPENSSL"] = True
      conf.env.append_value("CPPFLAGS", "-DHAVE_OPENSSL=1")
    else:

=== debian/changelog ===
nodejs (0.6.19~dfsg1-5ubuntu1) quantal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - This package is x86/arm only. Update control to match.
    - d/patches/2020_increase_test_timeout.patch: Increased default test
      timeout from 60 to 120 seconds to support reliable execution of all
      tests on armhf/armel architectures.
    - d/patches/2005_expected_failing_tests.patch:
      - Allow racey tests to fail: test-child-process-fork2.
      - Allow test-fs-watch to fail as LP buildd's don't support
        inotify.

 -- James Page <james.page@ubuntu.com>  Mon, 24 Sep 2012 10:43:19 +0100

nodejs (0.6.19~dfsg1-5) unstable; urgency=low

  * Team upload.
  * Fix node-waf so that it correctly looks for "nodejs" instead of
    "node" (patched node_addon.py)

 -- David Paleino <dapal@debian.org>  Fri, 21 Sep 2012 23:23:16 +0200

nodejs (0.6.19~dfsg1-4ubuntu1) quantal; urgency=low

  [ Daniel Holbach ]
  * Merged from Debian unstable. Remaining changes:
    - This package is x86/arm only. Update control to match.
    - d/patches/2020_increase_test_timeout.patch: Increased default test
      timeout from 60 to 120 seconds to support reliable execution of all
      tests on armhf/armel architectures.
    - d/patches/2005_expected_failing_tests.patch:
      - Allow racey tests to fail: test-child-process-fork2.
      - Allow test-fs-watch to fail as LP buildd's don't support
        inotify.

  [ James Page ]
  * Dropped:
    - d/patches/2005_expected_failing_tests.patch: Updated failing tests to
      include stack_overflow for armel/armhf - test relaxed in 2004 patch.

 -- James Page <james.page@ubuntu.com>  Tue, 18 Sep 2012 11:31:55 +0100

nodejs (0.6.19~dfsg1-4) unstable; urgency=medium

  * Update package relations:
    + Break only packages actually calling /usr/bin/node (directly or
      via env).
    + Tighten breaks for packages with fixed release.
  * Set urgency=medium as this change affects only packaging hints so
    should not need reset of aging timer in unstable.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 06 Aug 2012 14:51:31 +0200

nodejs (0.6.19~dfsg1-3) unstable; urgency=low

  [ Jérémy Lal ]
  * debian/patches:
    + 2012_fix_v8_3_10.patch, fix crash on exit when building
      against libv8-3.10.8.
    + 2013_waf_linkflags.patch, waf must support LINKFLAGS,
      Closes: #678563.

  [ Jonas Smedegaard ]
  * Rename binary node → nodejs:
    + Adjust paths of binary and manpage.
    + Fix avoid bogus explicit installation of debug files.
    + Adjust install scripts and add cleanup for old alternative.
    + Patch manpage to adjust command name.
    + Have binary package nodejs break any packages in Debian that
      reference /usr/bin/node.
    + Add new binary package nodejs-legacy, and have that (not nodejs)
      conflict with node.
    + Add NEWS entry.
    Closes: bug#611698, #681360. See also bug#614907. Thanks to
    tech-ctte and everyone else helping to resolve this.
  * Work around upstream shipping docs in wrong subdir, and disable huge
    patch 1002 attempting same but causing FTBFS for me. Keep patch 1002
    in source, to ease proof-reading by release team.
  * Add patch 2004 to fix FTBFS: Relax a test to work with slightly
    different output when linked against recent v8.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 28 Jul 2012 11:19:38 +0200

nodejs (0.6.19~dfsg1-2ubuntu3) quantal; urgency=low

  * Really fix FTBFS on arm* architectures.

 -- James Page <james.page@ubuntu.com>  Mon, 09 Jul 2012 17:02:19 +0100

nodejs (0.6.19~dfsg1-2ubuntu2) quantal; urgency=low

  * Fix FTBFS on arm* architectures:
    - d/patches/2005_expected_failing_tests.patch: Updated failing tests to 
      include stack_overflow for armel/armhf.

 -- James Page <james.page@ubuntu.com>  Mon, 09 Jul 2012 16:02:23 +0100

nodejs (0.6.19~dfsg1-2ubuntu1) quantal; urgency=low

  * Merge from Debian unstable, remaining changes:
    - This package is x86/arm only. Update control to match.
    - d/patches/2020_increase_test_timeout.patch: Increased default test
      timeout from 60 to 120 seconds to support reliable execution of all
      tests on armhf/armel architectures.
    - d/patches/2005_expected_failing_tests.patch:
      - Allow racey tests to fail: test-child-process-fork2.
      - Allow test-fs-watch to fail as LP buildd's don't support
        inotify.

 -- James Page <james.page@ubuntu.com>  Mon, 11 Jun 2012 12:37:26 +0100

nodejs (0.6.19~dfsg1-2) unstable; urgency=low

  * debian/patches:
    + 2005_expected_failing_tests.patch, more tests can timeout.
    + 1002_upstream_forgot_to_build_doc.patch, include docs from
      late release of version 0.6.19.
  * debian/nodejs.docs:
    + update path
    + include markdown files.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 06 Jun 2012 23:35:37 +0200

nodejs (0.6.19~dfsg1-1) unstable; urgency=low

  * Upstream update. 

 -- Jérémy Lal <kapouer@melix.org>  Wed, 06 Jun 2012 19:11:21 +0200

nodejs (0.6.18~dfsg1-1ubuntu1) quantal; urgency=low

  * Merge from Debian unstable, remaining changes:
    - This package is x86/arm only. Update control to match.
    - d/patches/2020_increase_test_timeout.patch: Increased default test
      timeout from 60 to 120 seconds to support reliable execution of all
      tests on armhf/armel architectures.
    - d/patches/2005_expected_failing_tests.patch:
      - Allow racey tests to fail: test-child-process-fork2.
      - Allow test-fs-watch to fail as LP buildd's don't support
        inotify.

 -- James Page <james.page@ubuntu.com>  Mon, 28 May 2012 12:07:34 +0100

nodejs (0.6.18~dfsg1-1) unstable; urgency=low

  * Upstream update.
  * debian/patches:
    + 1002_make_test_not_weak.patch removed, applied upstream.
    + unfuzz patches.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 16 May 2012 02:06:42 +0200

nodejs (0.6.17~dfsg1-1ubuntu1) quantal; urgency=low

  * Merge from Debian unstable, remaining changes:
    - This package is x86/arm only. Update control to match.


=== debian/control ===
Source: nodejs
Section: web
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
DM-Upload-Allowed: yes
Build-Depends: cdbs (>= 0.4.70~),
 devscripts,
 debhelper,
 dh-buildinfo,
 python,
 libv8-dev (>= 3.7),
 binutils,
 libssl-dev (>= 1.0.0g),
 libev-dev (>= 1:4.11),
 libc-ares-dev (>= 1.7.5),
 openssl (>= 1.0.0g),
 pkg-config,
 bash-completion,
 curl,
 procps,
 zlib1g-dev
Standards-Version: 3.9.3
Homepage: http://nodejs.org/
Vcs-Browser: http://git.debian.org/?p=collab-maint/nodejs.git
Vcs-Git: git://git.debian.org/git/collab-maint/nodejs.git

Package: nodejs-dev
Section: devel
Architecture: any-i386 any-amd64 armel armhf
Depends: nodejs (= ${binary:Version}),
 ${misc:Depends},
 python,
 libv8-dev (>= 3.7),
 libssl-dev (>= 1.0.0g),
 libev-dev (>= 1:4.11),
 libc-ares-dev (>= 1.7.5)
Description: Development files for Node.js
 Node.js provides an event-based server-side javascript engine.
 .
 It is similar in design to and influenced by systems like
 Ruby's Event Machine or Python's Twisted.
 .
 Node.js takes the event model a bit further - it presents the event
 loop as a language construct instead of as a library.
 .
 This package is needed to build plugins.

Package: nodejs
Architecture: any-i386 any-amd64 armel armhf
Depends: ${shlibs:Depends},
 ${misc:Depends}
Breaks:
 buddycloud-server (<= 0.3.1-1),
 carto (<= 0.4.6+ds1-1),
 coffeescript (<< 1.3.3-3~),
 node-bones (<= 2.0.1+ds1-3),
 node-cli (<= 0.4.2~20120411-1),
 node-express (<= 2.5.9-1),
 node-get (<= 1.1.5+ds1-1),
 node-jake (<= 0.2.32-1),
 node-less (<< 1.3.0~20120310-3~),
 node-mapnik (<= 0.6.7-2),
 node-mbtiles (<= 0.2.3-1),
 node-optimist (<= 0.3.1-1),
 node-semver (<= 1.0.13-1),
 node-tilelive (<= 4.2.1-3),
 node-uglify (<< 1.2.6-2~),
 node-vows (<= 0.6.3-1),
 npm (<= 1.1.4~dfsg-1),
Description: Node.js event-based server-side javascript engine
 Node.js is similar in design to and influenced by systems like
 Ruby's Event Machine or Python's Twisted.
 .
 It takes the event model a bit further - it presents the event
 loop as a language construct instead of as a library.
 .
 Node.js is bundled with several useful libraries to handle server tasks :
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: nodejs-dbg
Section: debug
Architecture: any-i386 any-amd64 armel armhf
Depends: ${misc:Depends},
 nodejs (= ${binary:Version})
Suggests: libv8-dbg
Description: Node.js event-based server-side javascript engine (debug)
 Node.js is similar in design to and influenced by systems like
 Ruby's Event Machine or Python's Twisted.
 .
 It takes the event model a bit further - it presents the event
 loop as a language construct instead of as a library.
 .
 Node.js is bundled with several useful libraries to handle server tasks :
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains the debugging symbols.

Package: nodejs-legacy
Priority: extra
Architecture: all
Depends: ${misc:Depends},
 nodejs (>= 0.6.19~dfsg1-3~)
Conflicts: node
Description: Node.js event-based server-side javascript engine (legacy symlink)
 Node.js is similar in design to and influenced by systems like
 Ruby's Event Machine or Python's Twisted.
 .
 It takes the event model a bit further - it presents the event
 loop as a language construct instead of as a library.
 .
 Node.js is bundled with several useful libraries to handle server tasks :
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains a symlink for legacy Node.js code requiring
 binary to be /usr/bin/node (not /usr/bin/nodejs as provided in Debian).
 .
 No other Debian packages should depend on this package.  For more
 information, see
 <http://lists.debian.org/debian-devel-announce/2012/07/msg00002.html>

=== debian/rules ===
#!/usr/bin/make -f

-include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

DEB_UPSTREAM_URL = http://nodejs.org/dist/v$(DEB_UPSTREAM_TARBALL_VERSION)/
DEB_UPSTREAM_TARBALL_BASENAME = node-v$(DEB_UPSTREAM_TARBALL_VERSION)

DEB_UPSTREAM_WGET_OPTS += --no-check-certificate
# ./deps/npm contains some non-DFSG files, repackaging is needed.
# Conveniently, remove unused software to ease debian/copyright maintenance.
DEB_UPSTREAM_REPACKAGE_EXCLUDES += \
./deps/npm/ \
./deps/openssl/ \
./deps/zlib/ \
./deps/uv/src/ares/ \
./deps/uv/src/unix/ev/ \
./deps/uv/include/ares*.h \
./deps/uv/include/uv-private/ev.h \
./deps/uv/include/uv-private/tree.h \
./tools/scons/ \
./tools/gyp/ \
./tools/closure_linter/

DEB_UPSTREAM_REPACKAGE_TAG = $(shell echo $(DEB_UPSTREAM_VERSION) | egrep -o "dfsg[0-9]+")

# suppress checking binary files, to not upset dpkg-source
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(doc/trademark-policy\.pdf|doc/mac_osx_nodejs_installer_logo\.png|doc/.*-white-stripe\.jpg|favicon\.ico|debian/(changelog|copyright(|_hints|_newhints)))$

DEB_CONFIGURE_NORMAL_ARGS = ""
DEB_CONFIGURE_EXTRA_FLAGS = --debug --without-npm --shared-v8 --shared-cares --shared-libev --shared-zlib --no-ssl2
DEB_CONFIGURE_SCRIPT_ENV += PREFIX="/usr"
DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean
#  * relax regression tests when targeted experimental suite
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test

# properly clean files from build, waf, test, python
clean::
	rm -f node
	rm -f node_g
	rm -f .lock-wscript
	rm -rf build
	rm -f test/fixtures/hello.txt
	rm -rf test/tmp
	find . -name "*.pyc" -delete
	rm -rf out

binary-post-install/nodejs::
	mv debian/nodejs/usr/bin/node debian/nodejs/usr/bin/nodejs
	mv debian/nodejs/usr/share/man/man1/node.1 debian/nodejs/usr/share/man/man1/nodejs.1

# remove *.json files from documentation, remove google-analytics calls
# TODO: when doc will be generated from markdown, remove it from doc/template.html
binary-install/nodejs::
	find debian/nodejs/usr/share/doc/nodejs -name *.json -delete
	sed -i -e '/document\.write/d' -e '/pageTracker/d' debian/nodejs/usr/share/doc/nodejs/api/*.html

# we have completion for nodejs-waf
install/nodejs-dev::
	dh_bash-completion

# Work around upstream shipping docs in wrong subdir
pre-build:: debian/replace-items
debian/replace-items: debian/stamp-copyright-check
	cp -at doc/api doc/api/api/*
	touch $@
binary-post-install/nodejs::
	rm -rf debian/nodejs/usr/share/doc/nodejs/api/api
clean::
	rm -rf $(patsubst doc/api/api/%,doc/api/%,$(wildcard doc/api/api/*))
	rm -f debian/replace-items

=== debian/watch ===
version=3
opts=downloadurlmangle=s/.*v(.*)\//http\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.gz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.gz/,\
dversionmangle=s/~dfsg\d+$// \
http://nodejs.org/dist v(\d+\.[02468]\.[.0-9]+)/

## nodejs 0.8.11-maemo1

=== debian/changelog ===
nodejs (0.8.11-maemo1) unstable; urgency=low

   * 'armv7%':'1', and 'arm_neon%':'1',  (from rasberrypi)
   * LINK=g++             (cause error otherwise)
   * --without-snapshot   (cause error otherwise)
   * --prefix=/opt/node   (optifying)
   * import simplejson as json  (using python2.5, not newer)
   * use explicitely python2.5 (unless it uses python2.3)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Sat, 14 Oct 2012 20:48:40 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif


configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	tar xvf node-v0.8.11.tar.gz

	#credits: http://krispypen.github.com/blog/2012/10/07/compile-nodejs-for-your-n900/
	patch -p0 < debian/patches/maemo5_armv5.diff

	#with old python (2.5)
	patch -p0 < debian/patches/maemo5_python25.diff

	#use python2.5 with every python file
	cd node-v0.8.11 ; find . -type f -print0 | xargs -0 sed -i 's/\/usr\/bin\/env python/\/usr\/bin\/env python2.5/g'

	#use python2.5	
	sed -i 's/python/python2.5/g' node-v0.8.11/Makefile
	sed -i 's/python/python2.5/g' node-v0.8.11/node.gyp
	sed -i 's/python/python2.5/g' node-v0.8.11/tools/build-changelog.sh
	sed -i 's/python/python2.5/g' node-v0.8.11/tools/test.py
	sed -i 's/python/python2.5/g' node-v0.8.11/deps/v8/DEPS
	sed -i 's/python/python2.5/g' node-v0.8.11/deps/v8/Makefile
	sed -i 's/python/python2.5/g' node-v0.8.11/test/pummel/test-child-process-spawn-loop.js
	sed -i 's/python/python2.5/g' node-v0.8.11/test/pummel/test-exec.js
	sed -i 's/python/python2.5/g' node-v0.8.11/test/simple/test-child-process-set-blocking.js
	sed -i 's/python/python2.5/g' node-v0.8.11/deps/v8/src/d8.gyp
	sed -i 's/python/python2.5/g' node-v0.8.11/deps/v8/src/macros.py
	sed -i 's/python/python2.5/g' node-v0.8.11/deps/v8/tools/fuzz-harness.sh
	sed -i 's/python/python2.5/g' node-v0.8.11/deps/v8/tools/presubmit.py
	sed -i 's/python/python2.5/g' node-v0.8.11/deps/v8/tools/test.py
	sed -i 's/python/python2.5/g' node-v0.8.11/deps/v8/tools/test-wrapper-gypbuild.py
	sed -i 's/python/python2.5/g' node-v0.8.11/deps/v8/tools/gyp/v8.gyp
	#sed -i 's/python\\/python2.5\\/g' node-v0.8.11/tools/js2c.py

	#same file (different version)
	sed -i 's/raise/None #raise/g' node-v0.8.11/tools/js2c.py
	sed -i 's/raise ("I/None #raise ("I/g' node-v0.8.11/deps/v8/tools/js2c.py

	
	#remove bat-files (just in case)
	find . -type f -name "*.bat" -exec rm {} \;

	#LINK is needed, why?
	cd node-v0.8.11 ; export LINK=g++ ; ./configure --prefix=/opt/node --without-snapshot

	touch configure-stamp

build: build-stamp
build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	cd node-v0.8.11 ; export LINK=g++ ; make
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	rm -rf node-v0.8.11
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	cd node-v0.8.11 ; export LINK=g++ ; make DESTDIR=$(CURDIR)/debian/nodejs install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
